using UnityEngine;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
            ModAPI.Register<DeadPeopleNoCollideBehaviour>();
        }

        public class DeadPeopleNoCollideBehaviour : MonoBehaviour
        {
            private void Start()
            {
                ModAPI.OnDeath += (sender, life) => {
                    foreach (PhysicalBehaviour child in life.transform.root.GetComponentsInChildren<PhysicalBehaviour>())
                    {
                        if (!child)
                            continue;

                        child.gameObject.SetLayer(10);
                        var layerSerialisation = child.GetComponent<LayerSerialisationBehaviour>();
                        if (!layerSerialisation)
                            layerSerialisation = child.gameObject.AddComponent<LayerSerialisationBehaviour>();
                        layerSerialisation.Layer = child.gameObject.layer;
                    }
                };
            }
        }
    }
}